Attribute VB_Name = "ESMiscFunc"
Option Explicit

'***************************************************************************
'*                                                                         *
'*                            API Declarations                             *
'*                                                                         *
'***************************************************************************

Public Declare Sub InitCommonControls Lib "comctl32.dll" ()
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long
Public Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long

'***************************************************************************
'*                                                                         *
'*                          Helper Global Vars                             *
'*                                                                         *
'***************************************************************************

Public CurrentDIAL As String
'Used to track which DIAL entry an INFO refers to when reading.

Public YesToAll As Boolean
'Self-explanitory, isn't it?

Public MWDir As String
'Morowind Directory path.

'***************************************************************************
'*                                                                         *
'*                          Main Record Arrays                             *
'*                                                                         *
'***************************************************************************

Public TES3() As ES_TES3
Public GMST() As ES_GMST
Public GLOB() As ES_GLOB
Public CLAS() As ES_CLAS
Public FACT() As ES_FACT
Public RACE() As ES_RACE
Public SOUN() As ES_SOUN
Public SKIL() As ES_SKIL
Public MGEF() As ES_MGEF
Public SCPT() As ES_SCPT
Public REGN() As ES_REGN
Public BSGN() As ES_BSGN
Public LTEX() As ES_LTEX
Public STAT() As ES_STAT
Public DOOR() As ES_DOOR
Public MISC() As ES_MISC
Public WEAP() As ES_WEAP
Public CONT() As ES_CONT
Public ENCH() As ES_ENCH
Public SPEL() As ES_SPEL
Public BODY() As ES_BODY
Public LIGH() As ES_LIGH
Public ARMO() As ES_ARMO
Public CLOT() As ES_CLOT
Public REPA() As ES_REPA
Public ACTI() As ES_ACTI
Public APPA() As ES_APPA
Public L_CK() As ES_LOCK
Public PROB() As ES_PROB
Public INGR() As ES_INGR
Public BOOK() As ES_BOOK
Public ALCH() As ES_ALCH
Public LEVI() As ES_LEVI
Public LEVC() As ES_LEVC
Public LAND() As ES_Unknown 'That's because I don't use it. Change if you do.
Public PGRD() As ES_PGRD
Public SNDG() As ES_SNDG
Public SSCR() As ES_SSCR
Public NPC_() As ES_NPC_
Public CREA() As ES_CREA
Public CELL() As ES_CELL
Public DIAL() As ES_DIAL
Public INFO() As ES_INFO
Public Unknown() As ES_Unknown

'Savegame-specific, raw for now:
Public CNTC() As ES_Unknown
Public CREC() As ES_Unknown
Public FMAP() As ES_Unknown
Public GAME() As ES_Unknown
Public JOUR() As ES_Unknown
Public KLST() As ES_Unknown
Public NPCC() As ES_Unknown
Public PCDT() As ES_Unknown
Public QUES() As ES_Unknown
Public REFR() As ES_Unknown
Public SPLM() As ES_Unknown
Public STLN() As ES_Unknown



'***************************************************************************
'*                                                                         *
'*                             Misc. Functions                             *
'*                                                                         *
'***************************************************************************

Public Function CleanUp()

ReDim TES3(0)
ReDim GMST(0)
ReDim GLOB(0)
ReDim CLAS(0)
ReDim FACT(0)
ReDim RACE(0)
ReDim SOUN(0)
ReDim SKIL(0)
ReDim MGEF(0)
ReDim SCPT(0)
ReDim REGN(0)
ReDim BSGN(0)
ReDim LTEX(0)
ReDim STAT(0)
ReDim DOOR(0)
ReDim MISC(0)
ReDim WEAP(0)
ReDim CONT(0)
ReDim ENCH(0)
ReDim SPEL(0)
ReDim BODY(0)
ReDim LIGH(0)
ReDim ARMO(0)
ReDim CLOT(0)
ReDim REPA(0)
ReDim ACTI(0)
ReDim APPA(0)
ReDim L_CK(0)
ReDim PROB(0)
ReDim INGR(0)
ReDim BOOK(0)
ReDim ALCH(0)
ReDim LEVI(0)
ReDim LEVC(0)
ReDim LAND(0)
ReDim PGRD(0)
ReDim SNDG(0)
ReDim SSCR(0)
ReDim NPC_(0)
ReDim CREA(0)
ReDim CELL(0)
ReDim DIAL(0)
ReDim INFO(0)
ReDim CNTC(0)
ReDim CREC(0)
ReDim FMAP(0)
ReDim GAME(0)
ReDim JOUR(0)
ReDim KLST(0)
ReDim NPCC(0)
ReDim PCDT(0)
ReDim QUES(0)
ReDim REFR(0)
ReDim SPLM(0)
ReDim STLN(0)
ReDim Unknown(0)
CurrentDIAL = ""


End Function

Public Function RemovePadding()

On Error Resume Next
If Not UBound(TES3) = 0 Then
    ReDim Preserve TES3(UBound(TES3) - 1)
Else
    Erase TES3
End If
If Not UBound(GMST) = 0 Then
    ReDim Preserve GMST(UBound(GMST) - 1)
Else
    Erase GMST
End If
If Not UBound(GLOB) = 0 Then
    ReDim Preserve GLOB(UBound(GLOB) - 1)
Else
    Erase GLOB
End If
If Not UBound(CLAS) = 0 Then
    ReDim Preserve CLAS(UBound(CLAS) - 1)
Else
    Erase CLAS
End If
If Not UBound(FACT) = 0 Then
    ReDim Preserve FACT(UBound(FACT) - 1)
Else
    Erase FACT
End If
If Not UBound(RACE) = 0 Then
    ReDim Preserve RACE(UBound(RACE) - 1)
Else
    Erase RACE
End If
If Not UBound(SOUN) = 0 Then
    ReDim Preserve SOUN(UBound(SOUN) - 1)
Else
    Erase SOUN
End If
If Not UBound(SKIL) = 0 Then
    ReDim Preserve SKIL(UBound(SKIL) - 1)
Else
    Erase SKIL
End If
If Not UBound(MGEF) = 0 Then
    ReDim Preserve MGEF(UBound(MGEF) - 1)
Else
    Erase MGEF
End If
If Not UBound(SCPT) = 0 Then
    ReDim Preserve SCPT(UBound(SCPT) - 1)
Else
    Erase SCPT
End If
If Not UBound(REGN) = 0 Then
    ReDim Preserve REGN(UBound(REGN) - 1)
Else
    Erase REGN
End If
If Not UBound(BSGN) = 0 Then
    ReDim Preserve BSGN(UBound(BSGN) - 1)
Else
    Erase BSGN
End If
If Not UBound(LTEX) = 0 Then
    ReDim Preserve LTEX(UBound(LTEX) - 1)
Else
    Erase LTEX
End If
If Not UBound(STAT) = 0 Then
    ReDim Preserve STAT(UBound(STAT) - 1)
Else
    Erase STAT
End If
If Not UBound(DOOR) = 0 Then
    ReDim Preserve DOOR(UBound(DOOR) - 1)
Else
    Erase DOOR
End If
If Not UBound(MISC) = 0 Then
    ReDim Preserve MISC(UBound(MISC) - 1)
Else
    Erase MISC
End If
If Not UBound(WEAP) = 0 Then
    ReDim Preserve WEAP(UBound(WEAP) - 1)
Else
    Erase WEAP
End If
If Not UBound(CONT) = 0 Then
    ReDim Preserve CONT(UBound(CONT) - 1)
Else
    Erase CONT
End If
If Not UBound(ENCH) = 0 Then
    ReDim Preserve ENCH(UBound(ENCH) - 1)
Else
    Erase ENCH
End If
If Not UBound(SPEL) = 0 Then
    ReDim Preserve SPEL(UBound(SPEL) - 1)
Else
    Erase SPEL
End If
If Not UBound(BODY) = 0 Then
    ReDim Preserve BODY(UBound(BODY) - 1)
Else
    Erase BODY
End If
If Not UBound(LIGH) = 0 Then
    ReDim Preserve LIGH(UBound(LIGH) - 1)
Else
    Erase LIGH
End If
If Not UBound(ARMO) = 0 Then
    ReDim Preserve ARMO(UBound(ARMO) - 1)
Else
    Erase ARMO
End If
If Not UBound(CLOT) = 0 Then
    ReDim Preserve CLOT(UBound(CLOT) - 1)
Else
    Erase CLOT
End If
If Not UBound(REPA) = 0 Then
    ReDim Preserve REPA(UBound(REPA) - 1)
Else
    Erase REPA
End If
If Not UBound(ACTI) = 0 Then
    ReDim Preserve ACTI(UBound(ACTI) - 1)
Else
    Erase ACTI
End If
If Not UBound(APPA) = 0 Then
    ReDim Preserve APPA(UBound(APPA) - 1)
Else
    Erase APPA
End If
If Not UBound(L_CK) = 0 Then
    ReDim Preserve L_CK(UBound(L_CK) - 1)
Else
    Erase L_CK
End If
If Not UBound(PROB) = 0 Then
    ReDim Preserve PROB(UBound(PROB) - 1)
Else
    Erase PROB
End If
If Not UBound(INGR) = 0 Then
    ReDim Preserve INGR(UBound(INGR) - 1)
Else
    Erase INGR
End If
If Not UBound(BOOK) = 0 Then
    ReDim Preserve BOOK(UBound(BOOK) - 1)
Else
    Erase BOOK
End If
If Not UBound(ALCH) = 0 Then
    ReDim Preserve ALCH(UBound(ALCH) - 1)
Else
    Erase ALCH
End If
If Not UBound(LEVI) = 0 Then
    ReDim Preserve LEVI(UBound(LEVI) - 1)
Else
    Erase LEVI
End If
If Not UBound(LEVC) = 0 Then
    ReDim Preserve LEVC(UBound(LEVC) - 1)
Else
    Erase LEVC
End If
If Not UBound(LAND) = 0 Then
    ReDim Preserve LAND(UBound(LAND) - 1)
Else
    Erase LAND
End If
If Not UBound(PGRD) = 0 Then
    ReDim Preserve PGRD(UBound(PGRD) - 1)
Else
    Erase PGRD
End If
If Not UBound(SNDG) = 0 Then
    ReDim Preserve SNDG(UBound(SNDG) - 1)
Else
    Erase SNDG
End If
If Not UBound(SSCR) = 0 Then
    ReDim Preserve SSCR(UBound(SSCR) - 1)
Else
    Erase SSCR
End If
If Not UBound(NPC_) = 0 Then
    ReDim Preserve NPC_(UBound(NPC_) - 1)
Else
    Erase NPC_
End If
If Not UBound(CREA) = 0 Then
    ReDim Preserve CREA(UBound(CREA) - 1)
Else
    Erase CREA
End If
If Not UBound(CELL) = 0 Then
    ReDim Preserve CELL(UBound(CELL) - 1)
Else
    Erase CELL
End If
If Not UBound(DIAL) = 0 Then
    ReDim Preserve DIAL(UBound(DIAL) - 1)
Else
    Erase DIAL
End If
If Not UBound(INFO) = 0 Then
    ReDim Preserve INFO(UBound(INFO) - 1)
Else
    Erase INFO
End If
If Not UBound(CNTC) = 0 Then
    ReDim Preserve CNTC(UBound(CNTC) - 1)
Else
    Erase CNTC
End If
If Not UBound(CREC) = 0 Then
    ReDim Preserve CREC(UBound(CREC) - 1)
Else
    Erase CREC
End If
If Not UBound(FMAP) = 0 Then
    ReDim Preserve FMAP(UBound(FMAP) - 1)
Else
    Erase FMAP
End If
If Not UBound(GAME) = 0 Then
    ReDim Preserve GAME(UBound(GAME) - 1)
Else
    Erase GAME
End If
If Not UBound(JOUR) = 0 Then
    ReDim Preserve JOUR(UBound(JOUR) - 1)
Else
    Erase JOUR
End If
If Not UBound(KLST) = 0 Then
    ReDim Preserve KLST(UBound(KLST) - 1)
Else
    Erase KLST
End If
If Not UBound(NPCC) = 0 Then
    ReDim Preserve NPCC(UBound(NPCC) - 1)
Else
    Erase NPCC
End If
If Not UBound(PCDT) = 0 Then
    ReDim Preserve PCDT(UBound(PCDT) - 1)
Else
    Erase PCDT
End If
If Not UBound(QUES) = 0 Then
    ReDim Preserve QUES(UBound(QUES) - 1)
Else
    Erase QUES
End If
If Not UBound(REFR) = 0 Then
    ReDim Preserve REFR(UBound(REFR) - 1)
Else
    Erase REFR
End If
If Not UBound(SPLM) = 0 Then
    ReDim Preserve SPLM(UBound(SPLM) - 1)
Else
    Erase SPLM
End If
If Not UBound(STLN) = 0 Then
    ReDim Preserve STLN(UBound(STLN) - 1)
Else
    Erase STLN
End If
If Not UBound(Unknown) = 0 Then
    ReDim Preserve Unknown(UBound(Unknown) - 1)
Else
    Erase Unknown
End If
CurrentDIAL = ""

End Function

Public Function IsTextEnd(str As String) As Boolean

Dim i As Long, count As Long

For i = 0 To Len(str) - 1
    If Mid(str, Len(str) - i, 1) = """" Then
        count = count + 1
    Else
        If count And 1 Then
            IsTextEnd = True
        Else
            IsTextEnd = False
        End If
        Exit Function
    End If
Next

End Function

'***************************************************************************
'*                                                                         *
'*                              Recycle Bin                                *
'*                                                                         *
'***************************************************************************

'This one should be in the List function:

'Check cells around it...
'
'Dim NearCell As ES_CELL
'
'For Each NearCell In CELL()
'    If (NearCell.DATAGridX = CELL(i).DATAGridX) And (NearCell.DATAGridY = CELL(i).DATAGridX + 1) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX) And (NearCell.DATAGridY = CELL(i).DATAGridX - 1) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX + 1) And (NearCell.DATAGridY = CELL(i).DATAGridX) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX + 1) And (NearCell.DATAGridY = CELL(i).DATAGridX + 1) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX + 1) And (NearCell.DATAGridY = CELL(i).DATAGridX - 1) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX - 1) And (NearCell.DATAGridY = CELL(i).DATAGridX) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX - 1) And (NearCell.DATAGridY = CELL(i).DATAGridX + 1) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX - 1) And (NearCell.DATAGridY = CELL(i).DATAGridX - 1) Then
'        'Extract stuff
'    ElseIf (NearCell.DATAGridX = CELL(i).DATAGridX - 1) And (NearCell.DATAGridY = CELL(i).DATAGridX) Then
'        'Extract stuff
'    End If
'Next
'END Check

